﻿using System;
using System.Runtime.InteropServices;
using System.Text;
using System.IO;

namespace UsandoPInvoke
{
    class Program
    {
        // Declaração das funções não gerenciadas: GetPrivateProfileString e 
        // WritePrivateProfileString
        [DllImport("kernel32.dll", EntryPoint = "GetPrivateProfileString")]
        private static extern int GetPrivateProfileString(string lpAppName,string lpKeyName, string lpDefault, StringBuilder lpReturnedString,int nSize, string lpFileName);

        [DllImport("kernel32.dll", EntryPoint = "WritePrivateProfileString")]
        private static extern bool WritePrivateProfileString(string lpAppName,string lpKeyName, string lpString, string lpFileName);

        static void Main(string[] args)
        {
            // Precisa usar o caminho completo ou Sistema Operacional vai tentar escrever 
            // o arquivo INI na pasta Windows causando problemas no Windows Vista /WIndows 7
            string nomeArquivoINI = Path.Combine(Directory.GetCurrentDirectory(),"Macoratti.ini");

            nomeArquivoINI = getCaminhoArquivoINI(nomeArquivoINI);
            
            string message = "Valor de UltimoAcesso em [Geral] é : {0}";

            // Escreve um novo valor no arquivo INI.
            WriteIniValue("Geral", "UltimoAcesso",DateTime.Now.ToString(), nomeArquivoINI);
            
            // Obtêm o valor contido no arquivo INI
            string val1 = GetIniValue("Geral", "NomeUsuario", nomeArquivoINI);
            string val2 = GetIniValue("Geral", "EnderecoURL", nomeArquivoINI);
            string val3 = GetIniValue("Geral", "UltimoAcesso", nomeArquivoINI);

            Console.WriteLine(message, val1 ?? "???");
            Console.WriteLine(message, val2 ?? "???");
            Console.WriteLine(message, val3 ?? "???");
            
            // Aguarda para continuar
            Console.WriteLine(Environment.NewLine);
            Console.WriteLine("Pressione ENTER para continuar.");
            Console.ReadLine();
            
            // Atualiza o arquivo INI
            WriteIniValue("Geral", "NomeUsuario","Macoratti - MVP", nomeArquivoINI);
            WriteIniValue("Geral", "EnderecoURL","http://www.macoratti.net - quase tudo para VB", nomeArquivoINI);
            WriteIniValue("Geral", "UltimoAcesso", DateTime.Now.ToString(), nomeArquivoINI);
            
            // Obtêm o novo valor
            val1 = GetIniValue("Geral", "NomeUsuario", nomeArquivoINI);
            val2 = GetIniValue("Geral", "EnderecoURL", nomeArquivoINI);
            val3 = GetIniValue("Geral", "UltimoAcesso", nomeArquivoINI);

            Console.WriteLine(message, val1 ?? "???");
            Console.WriteLine(message, val2 ?? "???");
            Console.WriteLine(message, val3 ?? "???");

            // Aguarda para continuar
            Console.WriteLine(Environment.NewLine);
            Console.WriteLine("Método Main encerrado. Pressione ENTER.");
            Console.ReadLine();
         }

        public static string GetIniValue(string section, string key,string nomeArquivo)
        {
            int chars = 256;
            StringBuilder buffer = new StringBuilder(chars);
            string sDefault = "";
            if (GetPrivateProfileString(section, key, sDefault,buffer, chars, nomeArquivo) != 0)
            {
                return buffer.ToString();
            }
            else
            {
                // Verifica o último erro Win32.
                int err = Marshal.GetLastWin32Error();
                return null;
            }
        }

        public static bool WriteIniValue(string section, string key,
        string value, string nomeArquivo)
        {
            return WritePrivateProfileString(section, key, value, nomeArquivo);
        }

        public static string getCaminhoArquivoINI(string caminhoArquivo)
        {
            if (caminhoArquivo.IndexOf("\\bin\\Debug") != -1)
            {
                caminhoArquivo = caminhoArquivo.Replace("\\bin\\Debug", "");
            }
            else if (caminhoArquivo.IndexOf("\\bin\\Release") != -1)
            {
                caminhoArquivo = caminhoArquivo.Replace("\\bin\\Release", "");
            }
            return caminhoArquivo; 
        }//fim 
   }
}
